/*****************************************************************************/
/*
                                   certman.h

VERSION HISTORY
---------------
23-APR-2017  MGD  initial
*/
/*****************************************************************************/

#ifndef CERTMAN_H_LOADED
#define CERTMAN_H_LOADED 1

#include <openssl/x509v3.h>
#include <openssl/bn.h>
#include <openssl/asn1.h>
#include <openssl/x509.h>
#include <openssl/x509_vfy.h>
#include <openssl/pem.h>
#include <openssl/bio.h>

/* days before expiry when renewal attempt begins */
#define CERTMAN_RENEW_DAYS 30

/* from [.acme-client-portable...]netproc.c */
#define CERTMAN_STAGE_CA "acme-staging.api.letsencrypt.org"

#define EXIT_FI_LI(status) \
{ printf ("Status:500\r\n\r\n[%s:%d]\r\n", FI_LI); exit(status); }

/* function prototypes */
void CertManAdminCert ();
char* CertManAltNames (X509*, char*);
int CertManAppendPrivKey (char*);
int CertManAsn1time (ASN1_TIME*, char*, int);
void CertManBegin ();
void CertManCLI (char*);
int CertManCheck (char*, char**);
int CertManCertify (char*);
void CertManHouseKeeper ();
int CertManInstall (char*);
void CertManLoad ();

#endif /* CERTMAN_H_LOADED */

/****************************************************************************/

